#ifndef PXmlReader_H
#define PXmlReader_H

// if this 
#define XMLREADERF_STRIP_TRAILING_WHITESPACES (1UL<<0)
#define XMLREADERF_STRIP_EMPTY_CONTENT (1UL<<1)


#define SERVICE_NO_ACTION 0xBAADBEEF 

class CService;

class ServiceAction : public CObject
    {
    public:
        ServiceAction( LPCTSTR lpszName )
            :   m_strServiceName( lpszName ),
                m_dwActionToTake( SERVICE_NO_ACTION ),
                m_pService( NULL )
        {
        }

        CString m_strServiceName;
        DWORD m_dwActionToTake;
        CService* m_pService;
    };

class PXmlReader
    {
    public:
        PXmlReader();
        virtual ~PXmlReader();
        virtual BOOL Read( LPCTSTR lpszFilename );
        virtual void OnStartElement( LPCTSTR lpszName, LPCTSTR* lpszAttributes );
        virtual void OnEndElement( LPCTSTR lpszName );
        virtual void OnCharacters( LPCTSTR lpszContent, int nLen );
        virtual void OnCharactersNotZeroTerminated( LPCTSTR lpszContent, int nLen );


        CObList m_Actions;
        ServiceAction* m_lpCurrentAction;
        BOOL m_bRecordStartType;

        DWORD m_dwFlags;
        LPVOID m_lpParser;
        TCHAR m_szContentBuffer[512];
        TCHAR m_szReadBuffer[512];
    };

#endif // PXmlReader_H
